#region Copyright Syncfusion Inc. 2001-2015.
// Copyright Syncfusion Inc. 2001-2015. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using System.IO;
//using Syncfusion.XlsIO;
using System.Diagnostics;
using System.Collections;

namespace GDBG_Sample
{
    public partial class Form1 : Form
    {        
        public Form1()
        {
            InitializeComponent();
            this.gridDataBoundGrid1.AllowProportionalColumnSizing = true;
            DataCollection dataSource = new DataCollection();
            Random rand = new Random();
            int r = rand.Next(100);
            for (int i = 0; i < 100; i++)
            {
                dataSource.Add(new Data(r.ToString(), "Category" + r.ToString(), "", r.ToString() + "Data"));
                r = rand.Next(100);
            }
            this.gridDataBoundGrid1.DataSource = dataSource;

            //Adding cellmodel
            this.gridDataBoundGrid1.Model.CellModels.Add("CustomComboBox", new CustomComboxBoxCellModel(this.gridDataBoundGrid1.Model));

            DataTable dt = new DataTable();
            dt.Columns.Add("Description");
            dt.Columns.Add("Desc_ID");
            dt.Rows.Add("Desc5", 5);
            dt.Rows.Add("Desc6", 6);

            //Assigning CellType
            this.gridDataBoundGrid1.Model.ColStyles["Description"].CellType = "CustomComboBox";
            this.gridDataBoundGrid1.Model.ColStyles["Description"].DataSource = dt;
            this.gridDataBoundGrid1.Model.ColStyles["Description"].DisplayMember = "Description";
            this.gridDataBoundGrid1.Model.ColStyles["Description"].ValueMember = "Desc_ID";
            this.gridDataBoundGrid1.Model.ColStyles["Description"].AutoCompleteInEditMode = GridComboSelectionOptions.AutoSuggest;
        }
    }
    #region Custom Cell Model/Renderer
    public class CustomComboxBoxCellModel : GridComboBoxCellModel
    {

        public CustomComboxBoxCellModel(GridModel grid)
            : base(grid)
        {
        }

        /// <summary>
        /// Creates a cell renderer.
        /// </summary>
        /// <param name="control">The grid control.</param>
        /// <returns>Cell renderer.</returns>
        public override GridCellRendererBase CreateRenderer(GridControlBase control)
        {
            return new CustomComboBoxCellRenderer(control, this);
        }
    }

    public class CustomComboBoxCellRenderer : GridComboBoxCellRenderer
    {
        GridStyleInfo cellStyle = null;

        public CustomComboBoxCellRenderer(GridControlBase grid, GridCellModelBase cellModel)
            : base(grid, cellModel)
        {
            cellStyle = GridStyleInfo.Default;
        }
        Hashtable styleCollection = new Hashtable();

        protected override void OnSetControlText(string text)
        {
            if (text == "Desc6")
            {
                if (!styleCollection.ContainsKey(GridRangeInfo.Cell(this.RowIndex, this.ColIndex)))
                {
                    GridStyleInfo style = GridStyleInfo.Empty;
                    style.CopyFrom(this.StyleInfo);
                    DataTable table = new DataTable();
                    table.Columns.Add("Description");
                    table.Columns.Add("Desc_ID");
                    table.Rows.Add("Desc1", 1);
                    table.Rows.Add("Desc2", 2);
                    table.Rows.Add("Desc3", 3);
                    style.DataSource = table.DefaultView;

                    style.DisplayMember = "Description";
                    style.ValueMember = "Desc_ID";

                    styleCollection.Add(GridRangeInfo.Cell(this.RowIndex, this.ColIndex), style);
                }
            }

            base.OnSetControlText(text);
        }

        protected override void OnKeyPress(KeyPressEventArgs e)
        {
            this.Grid.CurrentCell.ShowDropDown();
            base.OnKeyPress(e);
        }

        public override void OnPrepareViewStyleInfo(GridPrepareViewStyleInfoEventArgs e)
        {
            base.OnPrepareViewStyleInfo(e);

            if (styleCollection.Contains(GridRangeInfo.Cell(e.RowIndex, e.ColIndex)))
            {
                GridStyleInfo modifiedStyle = ((GridStyleInfo)styleCollection[GridRangeInfo.Cell(e.RowIndex, e.ColIndex)]);
                e.Style.DataSource = modifiedStyle.DataSource;
                e.Style.DisplayMember = modifiedStyle.DisplayMember;
                e.Style.ValueMember = modifiedStyle.ValueMember;
            }
        }
    }
    #endregion
}